import cv2
import yaml
import base64
from transformers import CLIPProcessor, CLIPModel
def ini(settings_path):
    with open(settings_path, "r") as file:
        settings = yaml.safe_load(file)
    threshold = settings['model-settings']['prediction-threshold']
    labels = settings['label-settings']['labels']
    labels_ = []
    model = CLIPModel.from_pretrained("openai/clip-vit-base-patch32")
    preprocess = CLIPProcessor.from_pretrained("openai/clip-vit-base-patch32")
    for label in labels:
        text = 'a photo of ' + label
        labels_.append(text)
    print("INIT COMPLETED!")
    return model, preprocess, labels_,  threshold

def recogn(image, model, preprocess, cam_num,  coded_image,labels,  threshold):
    img = cv2.cvtColor(image, cv2.COLOR_BGR2RGB) 
    inputs = preprocess(text=labels, images=img, return_tensors="pt", padding=True)
    outputs = model(**inputs)
    logits_per_image = outputs.logits_per_image  
    probs = logits_per_image.softmax(dim=1)  
    probs=probs.tolist()
    probs=probs[0]
    for i in range(len(probs)):
        probs[i]=round(probs[i],3)
    max_value = max(probs)
    if max_value>=threshold:
        answer= str(labels[probs.index(max_value)])
    else:
        answer= "Unknown" 
        
    if coded_image == False:
            prediction = {
                        'label': answer ,
                        'confidence': max_value,
                        'cam':cam_num
                    }
    else:
            prediction = {
                        'label': answer,
                        'confidence': max_value,
                        'image': base64.b64encode(image).decode('utf-8')

                    }
        
    return prediction
