import time
import cv2
from confluent_kafka import Producer
from confluent_kafka.admin import AdminClient, NewTopic
from threading import Thread
import torch.multiprocessing as mp
from .core import ini,recogn
import configparser
import zmq
import numpy as np
import base64
conf = {
    'bootstrap.servers': 'localhost:29092'
}

producer =Producer(conf)
def delivery_report(err, msg):
    """ Called once for each message produced to indicate delivery result.
        Triggered by poll() or flush(). """
    if err is not None:
        print('Message delivery failed: {}'.format(err))
    else:
        print('Message delivered to {} [{}]'.format(msg.topic(), msg.partition()))

def streamer(camera, socket):   
        obj = socket.recv_string()
        source_id = obj[:len(str(camera))]
        frame = obj[len(str(camera)):]
        if str(source_id) == str(camera):
            img = base64.b64decode(frame)
            img_np = np.frombuffer(img, dtype=np.uint8)
            img = cv2.imdecode(img_np, cv2.IMREAD_COLOR)
            return img


def run(cam_num, video_path,timer,port):  
            model, preprocess,  labels_, threshold = ini("/usr/lib/python3.8/dist-packages/envrec/set.yaml")
            later = time.time()
            print(timer)
            print(cam_num)
            context = zmq.Context()
            socket = context.socket(zmq.SUB)
            socket.setsockopt_string(zmq.SUBSCRIBE,"")
            socket.connect("tcp://127.0.0.1:"+str(port))
            print(port)
            while True:
                #print(int(abs(later - time.time())))
                if int(abs(later - time.time())) == timer:
                     print('search'+ str(cam_num))
                     try:
                         frame=streamer(cam_num,socket)
                         result=recogn(frame, model, preprocess, cam_num, False, labels_,threshold)
                         if result['label']!='Unknown':
                              producer.produce('env',  str(result['label']).replace("a photo of", "").encode(), callback=delivery_report,partition=cam_num)
                     except:
                         frame=streamer(cam_num,socket)
                         result=recogn(frame, model, preprocess, cam_num, False, labels_,threshold)
                         if result['label']!='Unknown':
                                producer.produce('env',  str(result['label']).replace("a photo of", "").encode(), callback=delivery_report,partition=cam_num)
                
                         
                     time.sleep(0.01)
                     later = time.time()
                     

def check_kafka(topic,num):
            a = AdminClient({'bootstrap.servers': 'localhost:29092'})
            new_topics = [NewTopic(topic, num_partitions=num, replication_factor=1) for topic in [str(topic)]]
            fs=a.create_topics(new_topics)
            for topic, f in fs.items():
                try:
                    f.result()
                    print("Topic {} created".format(topic))
                except Exception as e:
                    print("Failed to create topic {}: {}".format(topic, e))
def ini_reader(file):
    lst=[]
    arr=[]
    config = configparser.ConfigParser()
    config.read(file)
    i_val=float(config['timeout']['value'])
    for section in config.sections():
                if section.startswith('camera_'):
                    value = config.get(section, 'id')
                    lst.append(str(value))
                    value = config.get(section, 'port')
                    arr.append(int(value))
    return lst,i_val,arr


def main():
    try:
        mp.set_start_method('spawn')
    except RuntimeError:
        pass
    ncam,ival,PORTS=ini_reader('/usr/lib/python3.8/dist-packages/envrec/CLIP_config.ini')
    check_kafka('env',len(ncam))
    Processes = [mp.Process(target=run,args=(index,id,ival,PORTS[index])) for index,id in enumerate(ncam)]
    for p in Processes:
        p.start()
    for p in Processes:
        p.join()  
    